extends Control

var gamesize = "Small"
var targetaudience = "Young"
var platforms = []
var genres = []
var themes = []
var engine = "Texty"

## SETTERS
func set_game_size(txt):#This effects how long the developement of the game is
	gamesize = txt

func set_target_audience(txt):
	targetaudience = txt

func set_engine(txt):
	engine = txt

## ADD/REMOVE
func add_platform(txt):
	platforms.append(txt)

func remove_platform(txt):
	if(platforms.has(txt)):
		platforms.remove(platforms.find(txt))

func add_genre(txt):
	genres.append(txt)

func remove_genre(txt):
	if(genres.has(txt)):
		genres.remove(genres.find(txt))

func add_theme(txt):
	themes.append(txt)

func remove_theme(txt):
	if(themes.has(txt)):
		themes.remove(themes.find(txt))

## POPUP MENUS
func add_menu_to(where,items,amount = 1):#Adds a MenuButton to a Hbox
	for a in amount:
		var butmenu = MenuButton.new()
		butmenu.text = where.name
		if(amount!=1):
			butmenu.text +="# "+str(amount)
		for i in items:
			butmenu.get_popup().add_item(i)
		butmenu.get_popup().connect("id_pressed",self,"popup_menu_change",[butmenu])
		where.add_child(butmenu,true)

func popup_menu_change(idx,what):#An item changed on a popup menu
	what.text = what.get_popup().get_item_text(idx)
	var which = what.get_parent().name
	match(which):
		"makenewgame":#I'm going to assume engine as it is the only MenuButton outside a hbox
			set_engine(what.text)
		"platforms":
			 add_platform(what.text)
		"genres":
			 add_genre(what.text)
		"themes":
			 add_theme(what.text)

## Game Make
func register_game():#Sends the idea off to the studio for developement
	var phasetime = 0
	match(gamesize):
		"Small":
			phasetime+= 3
		"Medium":
			phasetime+= 7
		"Large":
			phasetime+= 15
		"AAA":
			phasetime+= 20
	if($VBoxContainer/gamesize/MMO.pressed == true):
		phasetime += phasetime/2
	get_parent().get_parent().games_in_developement[$VBoxContainer/gamename.text] = {
		"devstart":[get_parent().month,get_parent().week,get_parent().year],
		"Phase":0,#0=start,1-3 = actual phases, 4 = debug phase/release prep
		"phasetime":phasetime,
		"timer":2,
		"targetaudience":targetaudience,
		"platforms":platforms,
		"genres":genres,
		"themes":themes,
		"engine":engine,
		"Engine":34,
		"Gameplay":33,
		"Story":33,
		"Dialog":34,
		"Level Design":33,
		"AI":33,
		"World Building":34,
		"Graphics":33,
		"Sound":33,
		"techpoints":0,
		"designpoints":0,
		"bugpoints":0,
		"Engine_Flags":["ColorTextGraphics"],
		"Game_Tags":[gamesize,targetaudience,platforms,genres,themes,engine]
	}
	get_parent().add_game_dev($VBoxContainer/gamename.text)
	get_parent().get_node("Staff").mem["You"]["working_on"]=$VBoxContainer/gamename.text#WIP a menu to tell the staff to work on this title
	queue_free()

## MAIN
func _ready():
	var t = $"/root/loader".load_json(ProjectSettings.get("Game/Resources/Themesmod"))
	add_menu_to($VBoxContainer/themes,t,get_parent().get_parent().themeamount)
	add_menu_to($VBoxContainer/genres,["Action","Adventure","RPG","Simulation","Strategy","Casual"],get_parent().get_parent().genreamount)
	add_menu_to($VBoxContainer/platforms,get_parent().get_parent().platforms,get_parent().get_parent().platforms.size()/2)

	for i in get_parent().get_parent().engines:
		$VBoxContainer/engine.get_popup().add_item(i)

	$VBoxContainer/gamename.text = "Game #"+str(get_parent().get_parent().games.size()+get_parent().get_parent().games_in_developement.size()+1)
	var connections = [
		$VBoxContainer/confirm.connect("pressed",self,"register_game"),
		$VBoxContainer/gamesize/Small.connect("pressed",self,"set_game_size",["Small"]),
		$VBoxContainer/gamesize/Medium.connect("pressed",self,"set_game_size",["Medium"]),
		$VBoxContainer/gamesize/Large.connect("pressed",self,"set_game_size",["Large"]),
		$VBoxContainer/gamesize/TripleA.connect("pressed",self,"set_game_size",["AAA"]),
		$VBoxContainer/engine.get_popup().connect("id_pressed",self,"popup_menu_change",[$VBoxContainer/engine])
	]
	print_debug(connections)
#"The Meaning of life is to entertain Mister God"-Terry A Davis
#"Let us hear the conclusion of the whole matter: Fear God, and keep his commandments: for this is the whole duty of man." - Ecclesiastes 12:13